/**
   GeoShift (C) 2018 Beholder Corporation / FoxyProxy
 * support@getfoxyproxy.org
 *
 * This source code is proprietary, and released under the EULA available in the
 * LICENSE file at the root of this installation. Do not copy or re-use without
 * written permission.
 */

// Custom ajax request.
// params: spinnerSelector, btnSelector, url, successCallbackAndParams, params (optional)
// successCallbackAndParams is null or an object with two props: callback and params
// errorCallbackAndParams is null or an object with two props: callback and params
// URL parameters can be passed directly as part of |url| or as an object of key/value pairs in |params|; example:
// {url: 'http://foo.com', params: {'key1': 'value1', 'key2': 'value2'}} becomes http://foo.com?key1=value1&key2=value2.
// This is standard jquery behavior, nothing new.
// You can also just do:
// {url: 'http://foo.com?key1=value1&key2=value2'}
function act(options) {
  if (!options) return;
  var spinnerSelector = options.spinnerSelector || '',
		btnSelector = options.btnSelector || '',
    successCallbackAndParams = options.successCallbackAndParams,
		errorCallbackAndParams = options.errorCallbackAndParams,
    params = options.params;

  $(spinnerSelector).html('<i class="fa fa-refresh fa-spin fa-3x fp-orange"></i>');
  $(btnSelector).prop('disabled', true);
  $.ajax({
    dataType: "json",
    type: options.type || "GET",
    url: options.url,
    data: params,
    success: function(json) {
			$(btnSelector).prop('disabled', false);
			$(spinnerSelector).html('');
			if (Object.keys(json).length === 0) {
				// Empty object or array
      	if (errorCallbackAndParams) {
					// errorCallbackAndParams is an object with two props: callback and params
					errorCallbackAndParams.callback(json, errorCallbackAndParams.params);
        }
			}
      // Change the image to show success
      //$(spinnerSelector).html('<i class="fa fa-check"></i>&nbsp;' + (okMsg ? okMsg : ''));
      else if (successCallbackAndParams) {
        // successCallbackAndParams is an object with two props: callback and params
        successCallbackAndParams.callback(json, successCallbackAndParams.params);
      }
    },
    error: function(b,c,d) {
			$(btnSelector).prop('disabled', false);
      $(spinnerSelector).html('');
      if (errorCallbackAndParams) {
				// errorCallbackAndParams is an object with two props: callback and params
      	errorCallbackAndParams.callback(null, errorCallbackAndParams.params);
      }
    }
  });
}
